#include <stdio.h>
#include <stdlib.h>
#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  pragma comment(lib, "glew32.lib")
#  include "glew.h"
#  include "glut.h"
#  include "glext.h"
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

/*
** VF[_̃\[XvO̓ǂݍ݂Ɏg֐
*/
extern int readShaderSource(GLuint shader, const char *file);
extern void printShaderInfoLog(GLuint shader);
extern void printProgramInfoLog(GLuint program);

/*
** VF[_IuWFNg
*/
static GLuint vertShader;
static GLuint fragShader;
static GLuint gl2Program;

/*
** eϊs
*/
extern void orthogonalMatrix(float left, float right,
                             float bottom, float top,
                             float near, float far,
                             GLfloat *matrix);
static GLfloat projectionMatrix[16];
static GLint projectionMatrixLocation;

/*
** attribute ϐ position ̒_obt@IuWFNg
*/
static GLuint buffer;

/*
** ʕ\
*/
static void display(void)
{
  /* ʃNA */
  glClear(GL_COLOR_BUFFER_BIT);

  /* VF[_vOKp */
  glUseProgram(gl2Program);

  /* uniform ϐ projectionMatrix ɍsݒ肷 */
  glUniformMatrix4fv(projectionMatrixLocation, 1, GL_FALSE, projectionMatrix);

  /* index  0  attribute ϐɒ_Ήt */
  glEnableVertexAttribArray(0);

  /* _obt@IuWFNgƂ buffer w肷 */
  glBindBuffer(GL_ARRAY_BUFFER, buffer);

  /* _̊i[ꏊƏw肷 */
  glVertexAttribPointer(0, 2, GL_FLOAT, GL_FALSE, 0, 0);

  /* }`` */
  glDrawArrays(GL_LINE_LOOP, 0, 4);

  /* _obt@IuWFNg */
  glBindBuffer(GL_ARRAY_BUFFER, 0);

  /* index  0  attribute ϐ̒_Ƃ̑Ήt */
  glDisableVertexAttribArray(0);

  glFlush();
}

/*
** 
*/
static void init(void)
{
  /* VF[_vÕRpC^Nʂ𓾂ϐ */
  GLint compiled, linked;

  /* _obt@IuWFNg̃QƂ|C^ */
  typedef GLfloat Position[2];
  Position *position;

#if defined(WIN32)
  /* GLEW ̏ */
  GLenum err = glewInit();
  if (err != GLEW_OK) {
    fprintf(stderr, "Error: %s\n", glewGetErrorString(err));
    exit(1);
  }
#endif

  /* wiF */
  glClearColor(1.0, 1.0, 1.0, 1.0);

  /* VF[_IuWFNg̍쐬 */
  vertShader = glCreateShader(GL_VERTEX_SHADER);
  fragShader = glCreateShader(GL_FRAGMENT_SHADER);

  /* VF[_̃\[XvO̓ǂݍ */
  if (readShaderSource(vertShader, "simple.vert")) exit(1);
  if (readShaderSource(fragShader, "simple.frag")) exit(1);

  /* o[ebNXVF[_̃\[XvÕRpC */
  glCompileShader(vertShader);
  glGetShaderiv(vertShader, GL_COMPILE_STATUS, &compiled);
  printShaderInfoLog(vertShader);
  if (compiled == GL_FALSE) {
    fprintf(stderr, "Compile error in vertex shader.\n");
    exit(1);
  }

  /* tOgVF[_̃\[XvÕRpC */
  glCompileShader(fragShader);
  glGetShaderiv(fragShader, GL_COMPILE_STATUS, &compiled);
  printShaderInfoLog(fragShader);
  if (compiled == GL_FALSE) {
    fprintf(stderr, "Compile error in fragment shader.\n");
    exit(1);
  }

  /* vOIuWFNg̍쐬 */
  gl2Program = glCreateProgram();

  /* VF[_IuWFNg̃VF[_vOւ̓o^ */
  glAttachShader(gl2Program, vertShader);
  glAttachShader(gl2Program, fragShader);

  /* VF[_IuWFNg̍폜 */
  glDeleteShader(vertShader);
  glDeleteShader(fragShader);

  /* attribute ϐ position  index  0 Ɏw肷 */
  glBindAttribLocation(gl2Program, 0, "position");

  /* VF[_vÕN */
  glLinkProgram(gl2Program);
  glGetProgramiv(gl2Program, GL_LINK_STATUS, &linked);
  printProgramInfoLog(gl2Program);
  if (linked == GL_FALSE) {
    fprintf(stderr, "Link error.\n");
    exit(1);
  }

  /* seϊs߂ */
  orthogonalMatrix(0.0f, 1.0f, 0.0f, 1.0f, -1.0f, 1.0f, projectionMatrix);

  /* uniform ϐ projectionMatrix ̏ꏊ𓾂 */
  projectionMatrixLocation = glGetUniformLocation(gl2Program, "projectionMatrix");

  /* _obt@IuWFNgP */
  glGenBuffers(1, &buffer);

  /* _obt@IuWFNgɂS_̃̈mۂ */
  glBindBuffer(GL_ARRAY_BUFFER, buffer);
  glBufferData(GL_ARRAY_BUFFER, sizeof (Position) * 4, NULL, GL_STATIC_DRAW);

  /* _obt@IuWFNg̃vÕԂɃ}bv */
  position = (Position *)glMapBuffer(GL_ARRAY_BUFFER, GL_WRITE_ONLY);

  /* _obt@IuWFNg̃Ƀf[^ */
  position[0][0] =  0.9;
  position[0][1] =  0.9;
  position[1][0] = -0.9;
  position[1][1] =  0.9;
  position[2][0] = -0.9;
  position[2][1] = -0.9;
  position[3][0] =  0.9;
  position[3][1] = -0.9;

  /* _obt@IuWFNg̃vÕԂ؂藣 */
  glUnmapBuffer(GL_ARRAY_BUFFER);

  /* _obt@IuWFNg */
  glBindBuffer(GL_ARRAY_BUFFER, 0);
}

/*
** CvO
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  init();
  glutMainLoop();

  return 0;
}
